set(PLATFORM MINGW)

# the name of the target operating system
set(CMAKE_SYSTEM_NAME Windows)

# Generic toolchain setup
file(TO_CMAKE_PATH $ENV{DEPOT} DEPOT)
include( ${DEPOT}/config/target/gnu.cmake )

# Set RootFS
set( PLATFORM_ROOTFS "/opt/MinGW/" )

# which compilers to use for C and C++
set(CMAKE_C_COMPILER ${PLATFORM_ROOTFS}/usr/bin/i686-pc-mingw32-gcc)
set(CMAKE_CXX_COMPILER ${PLATFORM_ROOTFS}/usr/bin/i686-pc-mingw32-g++)
set(CMAKE_RC_COMPILER ${PLATFORM_ROOTFS}/usr/bin/i686-pc-mingw32-windres)
set(STRIP_TOOL ${PLATFORM_ROOTFS}/usr/bin/i686-pc-mingw32-strip)

set(CMAKE_CXX_FLAGS "-D_WIN32_WINNT=0x0601 -mms-bitfields")
set(CMAKE_CXX_STANDARD_LIBRARIES "-lwsock32 -lws2_32 ${CMAKE_CXX_STANDARD_LIBRARIES}")

# Where is the target environment 
set(PLATFORM_FIND_ROOT_PATH ${PLATFORM_ROOTFS}/usr/i686-pc-mingw32/sys-root/mingw/ )

# adjust the default behaviour of the FIND_XXX() commands:
# search headers and libraries in the target environment, search 
# programs in the host environment
set(CMAKE_FIND_ROOT_PATH_MODE_PROGRAM NEVER)
set(CMAKE_FIND_ROOT_PATH_MODE_LIBRARY ONLY)
set(CMAKE_FIND_ROOT_PATH_MODE_INCLUDE ONLY)

# Boost
set(Boost_USE_MULTITHREADED  ON)
set(Boost_USE_STATIC_RUNTIME OFF)
set(Boost_USE_STATIC_LIBS    OFF)

# GLIB
set(ENV{GLIB_DIR} ${PLATFORM_FIND_ROOT_PATH})

