set(PLATFORM VS)

# This one is important
set(CMAKE_SYSTEM_NAME Windows)

set(STRIP_TOOL "")
set(CMAKE_CXX_FLAGS "/W4 /EHsc /D_WIN32_WINNT=0x0601 /D_CRT_SECURE_NO_WARNINGS")
set(CMAKE_CXX_STANDARD_LIBRARIES "Ws2_32.lib ${CMAKE_CXX_STANDARD_LIBRARIES}") #TODO

# Set build targets
macro(SET_BUILD_TARGET build_dir build install)
	add_cmake_build_cmd( ${build_dir} "ALL_BUILD" "" ${build} )
	add_cmake_build_cmd( ${build_dir} "INSTALL" "" ${install} )
endmacro(SET_BUILD_TARGET)

macro(SET_LIBNAME outputvar project_name)
	SET(${outputvar} lib${PROJECT_PREFIX}${project_name})
	IF(${CMAKE_BUILD_TYPE} STREQUAL "Debug")
		SET(${outputvar} ${${outputvar}}d)
	ENDIF(${CMAKE_BUILD_TYPE} STREQUAL "Debug")
endmacro(SET_LIBNAME outputvar project_name)

macro(SET_TOOLNAME outputvar project_name)
	SET(${outputvar} ${project_name})
	IF(${CMAKE_BUILD_TYPE} STREQUAL "Debug")
		SET(${outputvar} ${${outputvar}}d)
	ENDIF(${CMAKE_BUILD_TYPE} STREQUAL "Debug")
endmacro(SET_TOOLNAME outputvar project_name)

# This macro adds the executable for the System
MACRO(add_system_executable PROJECT_NAME PROJECT_NAME_SOURCE_FILES)
	if("${PRE_BUILD_SUBSYSTEM}" STREQUAL "Windows" AND ${CMAKE_BUILD_TYPE} STREQUAL "Release")
		SetIfEmpty(PRE_BUILD_ICON_NAME "")
		ADD_EXECUTABLE(${PROJECT_NAME} WIN32 ${${PROJECT_NAME_SOURCE_FILES}} ${PRE_BUILD_ICON_NAME})
	else("${PRE_BUILD_SUBSYSTEM}" STREQUAL "Windows" AND ${CMAKE_BUILD_TYPE} STREQUAL "Release")
		ADD_EXECUTABLE(${PROJECT_NAME} ${${PROJECT_NAME_SOURCE_FILES}})
	endif("${PRE_BUILD_SUBSYSTEM}" STREQUAL "Windows" AND ${CMAKE_BUILD_TYPE} STREQUAL "Release")
ENDMACRO(add_system_executable)


# External packages
file( TO_CMAKE_PATH $ENV{EXTERNALS_PATH} EXTERNALS_PATH )

# Xerces
SET(ENV{XERCESCDIR} ${EXTERNALS_PATH})

# Lua
SET(ENV{LUA_DIR} ${EXTERNALS_PATH})

# DB
SET(ENV{DB_DIR} ${EXTERNALS_PATH})

# CEF
SET(ENV{CEF_DIR} ${EXTERNALS_PATH})

# ZLIB
SET(ENV{WINZLIB_DIR} ${EXTERNALS_PATH})

# CURL
SET(ENV{CURL_DIR} ${EXTERNALS_PATH})

# SKIA
SET(ENV{SKIA_DIR} ${EXTERNALS_PATH})

# PNG
SET(ENV{PNG_DIR} ${EXTERNALS_PATH})

# FreeType
SET(ENV{FREETYPE_DIR} $ENV{GTKMM_BASEPATH})

# GDK-PixBuf
SET(ENV{GDK-PIXBUF_DIR} $ENV{GTKMM_BASEPATH})

# GLIB
SET(ENV{GLIB_DIR} $ENV{GTKMM_BASEPATH})

# PANGO
SET(ENV{PANGO_DIR} $ENV{GTKMM_BASEPATH})

# CAIRO
SET(ENV{CAIRO_DIR} $ENV{GTKMM_BASEPATH})

# VLC
SET(ENV{LIB_DIR} ${EXTERNALS_PATH})

# GTK
#SET(GTK2_DEBUG TRUE)

# gtest
SET(GTEST_MSVC_SEARCH "MD") # << No creo que sirva esto
SET(GTEST_ROOT       ${EXTERNALS_PATH})

# Boost
SET(BOOST_ROOT  ${EXTERNALS_PATH} )
SET(Boost_NO_SYSTEM_PATHS TRUE)
#set(Boost_DEBUG TRUE)
set(Boost_USE_MULTITHREADED  ON)
set(Boost_USE_STATIC_RUNTIME OFF)
set(Boost_USE_STATIC_LIBS    OFF)

# no auto-link, 
# BOOST_PROGRAM_OPTIONS_DYN_LINK is required to properly import some symbols from program_options
# (http://lists.boost.org/boost-users/2009/11/54015.php)
add_definitions(/DBOOST_ALL_NO_LIB /DBOOST_PROGRAM_OPTIONS_DYN_LINK)
