# Set install directory, it is the build directory
set(CMAKE_INSTALL_PREFIX        $ENV{DEPOT}/install/${PLATFORM})
# Set prefix directory, it is the prefix directory for runtime
set(CMAKE_CONFIG_INSTALL_PREFIX $ENV{DEPOT}/install/${PLATFORM})

# Set build type Release, Debug, RelWithDebInfo if wasnt setted before, you use this to override build_type param 
#   set(CMAKE_BUILD_TYPE "Release")
#   set(CMAKE_BUILD_TYPE "Debug")
#   set(CMAKE_BUILD_TYPE "RelWithDebInfo")
#   set(CMAKE_BUILD_TYPE "MinSizeRel")
setIfEmpty( CMAKE_BUILD_TYPE "Debug" )

# Setup User config
setIfEmptyEnv( SETUP_USER USER_CONFIG_FILE ${CONFIG_PATH}/SetupUser.cmake )

# Set compile tests in true
setIfEmpty(COMPILE_TESTS 1)

# Set run tests in false
setIfEmpty(RUN_TESTS 0)

# Set info mode to off 
setIfEmpty(SILENT 1)

# Set project prefix to tvd
setIfEmpty(PROJECT_PREFIX dtv)

# Set to 0 when not a release candidate, non zero means that any generated 
#  svn tags will be treated as release candidates of given number
setIfEmpty(PROJECT_RELEASE_CANDIDATE 0)

# Set build to [shared|static]
OPTION_IF_EMPTY(BUILD_SHARED "Build the library shared." OFF)

