/*******************************************************************************

  Copyright (C) 2010, 2013 LIFIA - Facultad de Informatica - Univ. Nacional de La Plata

********************************************************************************

  This file is part of DTV-canvas implementation.

    DTV-canvas is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by the Free
  Software Foundation, either version 2 of the License.

    DTV-canvas is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
  A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License along with
  this program. If not, see <http://www.gnu.org/licenses/>.

********************************************************************************

  Este archivo es parte de la implementación de DTV-canvas.

    DTV-canvas es Software Libre: Ud. puede redistribuirlo y/o modificarlo
  bajo los términos de la Licencia Pública General Reducida GNU como es publicada por la
  Free Software Foundation, según la versión 2 de la licencia.

    DTV-canvas se distribuye esperando que resulte de utilidad, pero SIN NINGUNA
  GARANTÍA; ni siquiera la garantía implícita de COMERCIALIZACIÓN o ADECUACIÓN
  PARA ALGÚN PROPÓSITO PARTICULAR. Para más detalles, revise la Licencia Pública
  General Reducida GNU.

    Ud. debería haber recibido una copia de la Licencia Pública General Reducida GNU
  junto a este programa. Si no, puede verla en <http://www.gnu.org/licenses/>.

*******************************************************************************/

#include "mediaplayer.h"
#include "../rect.h"
#include "../point.h"
#include <util/log.h>

namespace canvas {
namespace dummy {

MediaPlayer::MediaPlayer()
{
}

MediaPlayer::~MediaPlayer( void )
{
}

//	Initialization
bool MediaPlayer::initialize( const Rect &rect, const std::string &url ) {
	LDEBUG("dummy::MediaPlayer", "Initialize: rect=(%d,%d,%d,%d), url=%s",
		rect.x, rect.y, rect.w, rect.h, url.c_str());	
	return true;
}

bool MediaPlayer::initialize( const std::string &url ) {
	LDEBUG("dummy::MediaPlayer", "Initialize: url=%s", url.c_str());	
	return true;
}

void MediaPlayer::finalize() {
	LDEBUG("dummy::MediaPlayer", "Finalize");
}

//	Stream operations
void MediaPlayer::play() {
	LDEBUG("dummy::MediaPlayer", "Play");
}

void MediaPlayer::stop() {
 	LDEBUG("dummy::MediaPlayer", "Stop");
}

void MediaPlayer::pause( bool needPause ) {
 	LDEBUG("dummy::MediaPlayer", "Pause: value=%d", needPause);
}

//	Volume
void MediaPlayer::mute( bool needMute ) {
 	LDEBUG("dummy::MediaPlayer", "mute: value=%d", needMute);
}

void MediaPlayer::setVolume( Volume vol ) {
 	LDEBUG("dummy::MediaPlayer", "volume: value=%d", vol);
}

//	Position/size
void MediaPlayer::setFullScreen() {
	LDEBUG("dummy::MediaPlayer", "set full screen" );	
}

void MediaPlayer::move( const Point &point ) {
	LDEBUG("dummy::MediaPlayer", "move(%d,%d)", point.x, point.y);
}

void MediaPlayer::resize( const Size &size ) {
	LDEBUG("dummy::MediaPlayer", "resize(%d,%d)", size.w, size.h);
}

}
}
