/*******************************************************************************

  Copyright (C) 2010, 2013 LIFIA - Facultad de Informatica - Univ. Nacional de La Plata

********************************************************************************

  This file is part of DTV-canvas implementation.

    DTV-canvas is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by the Free
  Software Foundation, either version 2 of the License.

    DTV-canvas is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
  A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License along with
  this program. If not, see <http://www.gnu.org/licenses/>.

********************************************************************************

  Este archivo es parte de la implementación de DTV-canvas.

    DTV-canvas es Software Libre: Ud. puede redistribuirlo y/o modificarlo
  bajo los términos de la Licencia Pública General Reducida GNU como es publicada por la
  Free Software Foundation, según la versión 2 de la licencia.

    DTV-canvas se distribuye esperando que resulte de utilidad, pero SIN NINGUNA
  GARANTÍA; ni siquiera la garantía implícita de COMERCIALIZACIÓN o ADECUACIÓN
  PARA ALGÚN PROPÓSITO PARTICULAR. Para más detalles, revise la Licencia Pública
  General Reducida GNU.

    Ud. debería haber recibido una copia de la Licencia Pública General Reducida GNU
  junto a este programa. Si no, puede verla en <http://www.gnu.org/licenses/>.

*******************************************************************************/

#include "player.h"
#include "mediaplayer.h"
#include "dummy/player.h"
#include "generated/config.h"
#if SYS_PLAYER_USE_VLC
#	include "impl/vlc/player.h"
#endif
#include <util/cfg/configregistrator.h>
#include <util/log.h>

namespace canvas {

REGISTER_INIT_CONFIG( gui_player ) {
	root().addNode( "player" )
#if SYS_PLAYER_USE_VLC
		.addValue( "use", "Player to initialize", std::string("vlc") );
#else
		.addValue( "use", "Player to initialize", std::string("dummy") );	
#endif
};


Player *Player::createPlayer() {
	const std::string &use = util::cfg::getValue<std::string> ("gui.player.use");
	LINFO( "player", "Using player: use=%s", use.c_str() );
	
#if SYS_PLAYER_USE_VLC
	if (use == "vlc") {
		return new vlc::Player();
	}
#endif

	return new dummy::Player();
}

Player::Player()
{
}

Player::~Player()
{
}

bool Player::initialize() {
	return true;
}

void Player::finalize() {
}

}

