/*******************************************************************************

  Copyright (C) 2010, 2013 LIFIA - Facultad de Informatica - Univ. Nacional de La Plata

********************************************************************************

  This file is part of DTV-luaz implementation.

    DTV-luaz is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by the Free
  Software Foundation, either version 2 of the License.

    DTV-luaz is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
  A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License along with
  this program. If not, see <http://www.gnu.org/licenses/>.

********************************************************************************

  Este archivo es parte de la implementación de DTV-luaz.

    DTV-luaz es Software Libre: Ud. puede redistribuirlo y/o modificarlo
  bajo los términos de la Licencia Pública General Reducida GNU como es publicada por la
  Free Software Foundation, según la versión 2 de la licencia.

    DTV-luaz se distribuye esperando que resulte de utilidad, pero SIN NINGUNA
  GARANTÍA; ni siquiera la garantía implícita de COMERCIALIZACIÓN o ADECUACIÓN
  PARA ALGÚN PROPÓSITO PARTICULAR. Para más detalles, revise la Licencia Pública
  General Reducida GNU.

    Ud. debería haber recibido una copia de la Licencia Pública General Reducida GNU
  junto a este programa. Si no, puede verla en <http://www.gnu.org/licenses/>.

*******************************************************************************/

#include "middleware.h"
#include "../lua.h"
#include <zapper/plugin/pluginmanager.h>
#include <boost/foreach.hpp>
#include <boost/signal.hpp>

namespace luaz {
namespace middleware {


namespace impl {
	static zapper::plugin::PluginManager *mgr = NULL;
	static lua_State *st=NULL;
	static bool connected=false;
}

static std::string gingaVersion() {
	return "0.0.0.0";
}

static int l_getApplications( lua_State *L ) {
	lua_newtable(L);
	return 1;
}

static int l_haveApplications( lua_State *L ) {
	int res=0;
	lua_pushnumber(L, res );
	return 1;
}

static int l_runApplication( lua_State* /*L*/ ) {
	return 0;
}

static int l_lock( lua_State* /*L*/ ) {
	return 0;
}

static void connectNotifications() {
}

static int l_isEnabled( lua_State *L ) {
	return lua::isPluginEnabled( L, impl::mgr, "Middleware" );
}

static int l_enable( lua_State *L ) {
	return lua::enablePlugin( L, impl::mgr, "Middleware" );
}

static const struct luaL_Reg middleware_methods[] = {
	{ "isEnabled",        l_isEnabled        },	
	{ "enable",           l_enable           },
	{ "getApplications",  l_getApplications  },
	{ "haveApplications", l_haveApplications },
	{ "runApplication",   l_runApplication   },
	{ "lock",             l_lock             },
	{ NULL,               NULL               }
};

//	Public methods
void attach( std::vector<std::string> &/*deps*/ ) {
}

void initialize( zapper::plugin::PluginManager *mgr ) {
	impl::mgr = mgr;
	connectNotifications();	
	impl::st = NULL;
}

void finalize( void ) {
	impl::mgr = NULL;
}

void start( lua_State *st ) {
	impl::st = st;
	luaL_register( st, "middleware", middleware_methods );

	//	Setup ginga NCL version variable
	lua::setGlobal( st, "gingaNCLVersion", gingaVersion().c_str() );
}

void stop( void ) {
	impl::st = NULL;
}

void onConnectionChanged( bool isRegistered ) {
	if (isRegistered) {
		connectNotifications();
	}
	else {
		impl::connected=false;
	}
}

}
}

