/*******************************************************************************

  Copyright (C) 2010, 2013 LIFIA - Facultad de Informatica - Univ. Nacional de La Plata

********************************************************************************

  This file is part of DTV-luaz implementation.

    DTV-luaz is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by the Free
  Software Foundation, either version 2 of the License.

    DTV-luaz is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
  A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License along with
  this program. If not, see <http://www.gnu.org/licenses/>.

********************************************************************************

  Este archivo es parte de la implementación de DTV-luaz.

    DTV-luaz es Software Libre: Ud. puede redistribuirlo y/o modificarlo
  bajo los términos de la Licencia Pública General Reducida GNU como es publicada por la
  Free Software Foundation, según la versión 2 de la licencia.

    DTV-luaz se distribuye esperando que resulte de utilidad, pero SIN NINGUNA
  GARANTÍA; ni siquiera la garantía implícita de COMERCIALIZACIÓN o ADECUACIÓN
  PARA ALGÚN PROPÓSITO PARTICULAR. Para más detalles, revise la Licencia Pública
  General Reducida GNU.

    Ud. debería haber recibido una copia de la Licencia Pública General Reducida GNU
  junto a este programa. Si no, puede verla en <http://www.gnu.org/licenses/>.

*******************************************************************************/

/*
 * videotoggle.cpp
 *
 *  Created on: Jun 17, 2011
 *      Author: gonzalo
 */

#include "luawgt.h"

#include "wgt.h"
#include "../widget/videotoggle.h"

#include <boost/make_shared.hpp>

#include <iostream>

namespace wgt {

namespace videotoggle {

std::map<WidgetId, VideoTogglePtr> _widgets;

int create(lua_State* L)
{
	VideoTogglePtr w = boost::make_shared<VideoToggle>();
	WidgetId id = Wgt::view()->addWidget(w);
	_widgets[id] = w;

	lua_pushnumber(L, id);
	return 1;
}

int setText(lua_State* L){
	int narg = 2;
	const WidgetId id      = luaL_checkint(L, narg++);
	const std::string text = luaL_checkstring(L, narg++);

	VideoTogglePtr widget = _widgets[id];
	widget->setText(text);

	return 0;
}

void init(lua_State *L){
	std::cout << "[lua] LuaVideoToggle::init" << std::endl;
	const struct luaL_Reg methods[] = {
			{"new",     create},
			{"setText", setText},
			{NULL,  NULL}
	};

	luaL_register(L, "videotoggle", methods);
}

} // videotoggle

} // wgt
