/*******************************************************************************

  Copyright (C) 2010, 2011 LIFIA - Facultad de Informatica - Univ. Nacional de La Plata

********************************************************************************

  This file is part of DTV-connector implementation.

    DTV-connector is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by the Free
  Software Foundation, either version 2 of the License.

    DTV-connector is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
  A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License along with
  this program. If not, see <http://www.gnu.org/licenses/>.

********************************************************************************

  Este archivo es parte de la implementación de DTV-connector.

    DTV-connector es Software Libre: Ud. puede redistribuirlo y/o modificarlo
  bajo los términos de la Licencia Pública General Reducida GNU como es publicada por la
  Free Software Foundation, según la versión 2 de la licencia.

    DTV-connector se distribuye esperando que resulte de utilidad, pero SIN NINGUNA
  GARANTÍA; ni siquiera la garantía implícita de COMERCIALIZACIÓN o ADECUACIÓN
  PARA ALGÚN PROPÓSITO PARTICULAR. Para más detalles, revise la Licencia Pública
  General Reducida GNU.

    Ud. debería haber recibido una copia de la Licencia Pública General Reducida GNU
  junto a este programa. Si no, puede verla en <http://www.gnu.org/licenses/>.

*******************************************************************************/
#include "funcs.h"
#include "../generic.h"
#include <string>
#include <util/log.h>

namespace tuner {
namespace desc {

bool fnc04eParser( MapOfDescriptors &descriptors, BYTE *descPayload, size_t /*len*/ ) {
	tuner::desc::MapOfDescriptors::const_iterator it = descriptors.find( tuner::desc::ident::extended_event );
	if (it == descriptors.end()) {
		ExtendedEventDescriptor tmp;
		descriptors[0x4e] = tmp;
	}
	size_t offset = 0;
	ExtendedEvent desc;
	ExtendedEventDescriptor &descVec = (ExtendedEventDescriptor&) descriptors[0x4e].get<tuner::desc::ExtendedEventDescriptor>();

	BYTE number = RB(descPayload,offset);
	BYTE desc_number = (number & 0xF0) >> 4;
	BYTE desc_lastNumber = (number & 0x0F);

	offset += parseLanguage( desc.language, descPayload+offset );

	BYTE lenItems = RB(descPayload,offset);
	size_t last = offset+lenItems;
	while (offset < last) {
		ExtendedEventItem item;

		offset += parseText( item.description, descPayload+offset );
		offset += parseText( item.content, descPayload+offset );
		desc.items.push_back(item);
	}
	offset += parseText( desc.text, descPayload+offset );

	if (desc_number == 0) {
		descVec.resize(desc_lastNumber+1);
		descVec[0] = desc;
	} else {
		descVec[desc_number] = desc;
	}

	show(desc);
	return true;
}

void show( const ExtendedEvent &desc ) {
	LTRACE("TAG::4E", "Extended event: languaje=%s text=%s nitems=%d",
		desc.language.code(), desc.text.c_str(), desc.items.size());
}

}
}
