/*******************************************************************************

Copyright (C) 2010, 2011 LIFIA - Facultad de Informatica - Univ. Nacional de La Plata

********************************************************************************

This file is part of DTV-connector implementation.

DTV-connector is free software: you can redistribute it and/or modify it
under the terms of the GNU Lesser General Public License as published by the Free
Software Foundation, either version 2 of the License.

DTV-connector is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along with
this program. If not, see <http://www.gnu.org/licenses/>.

********************************************************************************

Este archivo es parte de la implementación de DTV-connector.

DTV-connector es Software Libre: Ud. puede redistribuirlo y/o modificarlo
bajo los términos de la Licencia Pública General Reducida GNU como es publicada por la
Free Software Foundation, según la versión 2 de la licencia.

DTV-connector se distribuye esperando que resulte de utilidad, pero SIN NINGUNA
GARANTÍA; ni siquiera la garantía implícita de COMERCIALIZACIÓN o ADECUACIÓN
PARA ALGÚN PROPÓSITO PARTICULAR. Para más detalles, revise la Licencia Pública
General Reducida GNU.

Ud. debería haber recibido una copia de la Licencia Pública General Reducida GNU
junto a este programa. Si no, puede verla en <http://www.gnu.org/licenses/>.

*******************************************************************************/
#include "funcs.h"
#include "../generic.h"
#include <boost/foreach.hpp>
#include <util/log.h>

namespace tuner {
namespace desc {

bool fnc058Parser( MapOfDescriptors &descriptors, BYTE *descPayload, size_t len ) {
	size_t offset=0;
	LocalTimeOffsetDescriptor desc;

	while (offset < len) {
		LocalTimeOffsetStruct off;

		offset += parseLanguage(off.countryCode,descPayload+offset);

		{
			BYTE tmp = RB(descPayload,offset);
			off.countryRegion = tmp >> 2;
			off.localTimeOffsetPolarity = (tmp & 0x00000001) ? true : false;
		}

		off.localTimeOffset = RW(descPayload,offset);
		off.changingDate = RW(descPayload,offset);

		{
			DWORD tmp1 = RDW(descPayload,offset);
			BYTE tmp2 = RB(descPayload,offset);
			
			off.timeOfChange = (tmp1 & 0xFFFFFF00) >> 8;
			off.nextTimeOffset = ((tmp1 & 0x000000FF) << 8) | tmp2;
		}

		desc.push_back( off );
	}

	descriptors[0x58] = desc;
	show( desc );

	return true;
}

void show( const LocalTimeOffsetDescriptor &desc ) {
	BOOST_FOREACH( const LocalTimeOffset &lt, desc ) {
		LTRACE("TAG::58", "Country=%s, Region=%02x, Polarity=%d, Offset=%04x, chgDate=%04x, chgTime=%06x, Next=%04x",
			lt.countryCode.code(), lt.countryRegion, lt.localTimeOffsetPolarity, lt.localTimeOffset,
			lt.changingDate, lt.timeOfChange, lt.nextTimeOffset);
	}
}

}
}

