/*******************************************************************************

  Copyright (C) 2010, 2011 LIFIA - Facultad de Informatica - Univ. Nacional de La Plata

********************************************************************************

  This file is part of DTV-connector implementation.

    DTV-connector is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by the Free
  Software Foundation, either version 2 of the License.

    DTV-connector is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
  A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License along with
  this program. If not, see <http://www.gnu.org/licenses/>.

********************************************************************************

  Este archivo es parte de la implementación de DTV-connector.

    DTV-connector es Software Libre: Ud. puede redistribuirlo y/o modificarlo
  bajo los términos de la Licencia Pública General Reducida GNU como es publicada por la
  Free Software Foundation, según la versión 2 de la licencia.

    DTV-connector se distribuye esperando que resulte de utilidad, pero SIN NINGUNA
  GARANTÍA; ni siquiera la garantía implícita de COMERCIALIZACIÓN o ADECUACIÓN
  PARA ALGÚN PROPÓSITO PARTICULAR. Para más detalles, revise la Licencia Pública
  General Reducida GNU.

    Ud. debería haber recibido una copia de la Licencia Pública General Reducida GNU
  junto a este programa. Si no, puede verla en <http://www.gnu.org/licenses/>.

*******************************************************************************/
#include "funcs.h"
#include "../generic.h"
#include <util/log.h>
#include <boost/foreach.hpp>

namespace tuner {
namespace desc {

bool fnc0c1Parser( MapOfDescriptors &descriptors, BYTE *descPayload, size_t /*len*/ ) {
	DigitalCopyControl desc;
	size_t offset = 0;

	util::BYTE tmp = RB(descPayload,offset);
	desc.drcd = (tmp & 0xC0) >> 6;
	desc.mbFlag = (tmp & 0x20) == 0x20;
	desc.ccFlag = (tmp & 0x10) == 0x10;
	desc.cct = (tmp & 0x0C) >> 2;
	if (desc.cct != 0x00) {
		desc.apscd = (tmp & 0x03);
	} else {
		desc.apscd = 0x00;
	}
	if (desc.mbFlag) {
		desc.mb = RB(descPayload,offset);
	}
	if (desc.ccFlag) {
		util::BYTE len = RB(descPayload,offset);
		util::BYTE pos = 0x00;
		while (pos<len) {
			ComponentControl cc;
			cc.ct = RB(descPayload,offset);
			pos ++;
			tmp = RB(descPayload,offset);
			pos ++;
			cc.drcd = (tmp & 0xC0) >> 6;
			cc.mbFlag = (tmp & 0x20) == 0x20;
			cc.cct = (tmp & 0x0C) >> 2;
			if (cc.cct != 0x00) {
				cc.apscd = (tmp & 0x03);
			} else {
				cc.apscd = 0x00;
			}
			if (cc.mbFlag) {
				cc.mb = RB(descPayload,offset);
				pos++;
			}
			desc.componentControls.push_back(cc);
		}
	}

	descriptors[ident::digital_copy_control] = desc;
	LTRACE("TAG::C1", "Digital Copy Control: data=0x%.2x type=0x%.2x", desc.drcd, desc.cct);
	return true;
}

}
}
