/*******************************************************************************

  Copyright (C) 2010, 2011 LIFIA - Facultad de Informatica - Univ. Nacional de La Plata

********************************************************************************

  This file is part of DTV-connector implementation.

    DTV-connector is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by the Free
  Software Foundation, either version 2 of the License.

    DTV-connector is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
  A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License along with
  this program. If not, see <http://www.gnu.org/licenses/>.

********************************************************************************

  Este archivo es parte de la implementación de DTV-connector.

    DTV-connector es Software Libre: Ud. puede redistribuirlo y/o modificarlo
  bajo los términos de la Licencia Pública General Reducida GNU como es publicada por la
  Free Software Foundation, según la versión 2 de la licencia.

    DTV-connector se distribuye esperando que resulte de utilidad, pero SIN NINGUNA
  GARANTÍA; ni siquiera la garantía implícita de COMERCIALIZACIÓN o ADECUACIÓN
  PARA ALGÚN PROPÓSITO PARTICULAR. Para más detalles, revise la Licencia Pública
  General Reducida GNU.

    Ud. debería haber recibido una copia de la Licencia Pública General Reducida GNU
  junto a este programa. Si no, puede verla en <http://www.gnu.org/licenses/>.

*******************************************************************************/
#include "funcs.h"
#include "../generic.h"
#include <boost/foreach.hpp>
#include <util/log.h>

namespace tuner {
namespace desc {

bool fnc0faParser( MapOfDescriptors &descriptors, BYTE *descPayload, size_t len ) {
	size_t offset=0;
	TerrestrialDeliverySystemDescriptor desc;

	util::WORD data = RW(descPayload,offset);
	desc.area     = (data & 0xFFF0) >> 4;
	desc.interval = (data & 0x000C) >> 2;
	desc.mode     = data & 0x0003;

	while (offset < len) {
		data = RW(descPayload,offset);
		desc.frequencies.push_back( data );
	}
	descriptors[ident::terrestrial_delivery_system] = desc;

	LTRACE("TAG::FA", "Terrestrial Delivery: area=0x%.4x, interval=0x%.2x, mode=0x%.2x", desc.area, desc.interval, desc.mode);
	BOOST_FOREACH( util::WORD freq, desc.frequencies ) {
		LTRACE("TAG::FA", "\tfrequency=%d", freq);
	}
	return true;
}

}
}
