/*******************************************************************************

  Copyright (C) 2010, 2011 LIFIA - Facultad de Informatica - Univ. Nacional de La Plata

********************************************************************************

  This file is part of DTV-connector implementation.

    DTV-connector is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by the Free
  Software Foundation, either version 2 of the License.

    DTV-connector is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
  A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License along with
  this program. If not, see <http://www.gnu.org/licenses/>.

********************************************************************************

  Este archivo es parte de la implementacin de DTV-connector.

    DTV-connector es Software Libre: Ud. puede redistribuirlo y/o modificarlo
  bajo los trminos de la Licencia Pblica General Reducida GNU como es publicada por la
  Free Software Foundation, segn la versin 2 de la licencia.

    DTV-connector se distribuye esperando que resulte de utilidad, pero SIN NINGUNA
  GARANTA; ni siquiera la garanta implcita de COMERCIALIZACIN o ADECUACIN
  PARA ALGN PROPSITO PARTICULAR. Para ms detalles, revise la Licencia Pblica
  General Reducida GNU.

    Ud. debera haber recibido una copia de la Licencia Pblica General Reducida GNU
  junto a este programa. Si no, puede verla en <http://www.gnu.org/licenses/>.

*******************************************************************************/
#include "captiondata.h"
#include <util/log.h>

namespace tuner {
namespace arib {

CaptionData::CaptionData( BYTE groupID, QWORD pts, util::Buffer &buf )
{
	_group = groupID;
	_pts = pts;
	_unit.swap(buf);
}

CaptionData::~CaptionData( void )
{
}

BYTE CaptionData::group() const {
	return _group;
}

QWORD CaptionData::pts() const {
	return _pts;
}

const util::Buffer &CaptionData::dataUnit() const {
	return _unit;
}

void CaptionData::show() const {
	LDEBUG( "arib::Statement", "GroupID=%02x, pts=%010llx, unit=%d",
		_group, _pts, _unit.length() );
}

//	Management
Management::Management( BYTE groupID, QWORD pts, util::Buffer &buf, const CaptionLanguages &langs )
	: CaptionData( groupID, pts, buf ), _langs(langs)
{
}

Management::~Management()
{
}

const CaptionLanguages &Management::langs() const {
	return _langs;
}

void Management::show() const {
	LDEBUG( "arib::Management", "GroupID=%02x, pts=%010llx, unit=%d, langs=%d",
		group(), pts(), dataUnit().length(), _langs.size() );
}

}
}

