/*******************************************************************************

  Copyright (C) 2010, 2011 LIFIA - Facultad de Informatica - Univ. Nacional de La Plata

********************************************************************************

  This file is part of DTV-util implementation.

    DTV-util is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by the Free
  Software Foundation, either version 2 of the License.

    DTV-util is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
  A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License along with
  this program. If not, see <http://www.gnu.org/licenses/>.

********************************************************************************

  Este archivo es parte de la implementacin de DTV-util.

    DTV-util es Software Libre: Ud. puede redistribuirlo y/o modificarlo
  bajo los trminos de la Licencia Pblica General Reducida GNU como es publicada por la
  Free Software Foundation, segn la versin 2 de la licencia.

    DTV-util se distribuye esperando que resulte de utilidad, pero SIN NINGUNA
  GARANTA; ni siquiera la garanta implcita de COMERCIALIZACIN o ADECUACIN
  PARA ALGN PROPSITO PARTICULAR. Para ms detalles, revise la Licencia Pblica
  General Reducida GNU.

    Ud. debera haber recibido una copia de la Licencia Pblica General Reducida GNU
  junto a este programa. Si no, puede verla en <http://www.gnu.org/licenses/>.

*******************************************************************************/

#include "dispatcher.h"
#include "generated/config.h"
#if IO_USE_EV
#	include "ev/dispatcher.h"
#endif

#include "../cfg/configregistrator.h"
#include <boost/bind.hpp>


namespace util {
namespace io {

REGISTER_INIT_CONFIG( io ) {
	root().addNode( "io" )
#if IO_USE_EV
		.addValue( "use", "Event loop to use", std::string("ev") )
#endif
	;
}

Dispatcher *Dispatcher::create() {
	const std::string &use = util::cfg::getValue<std::string> ("io.use");
#if IO_USE_EV
	if (use == "ev") {
		return new ev::Dispatcher();
	}
#endif

	assert(false);
	return NULL;
}

Dispatcher::Dispatcher()
	: _pool("ev::io")
{
}

Dispatcher::~Dispatcher()
{
}

//	Initialization
bool Dispatcher::initialize() {
	return true;
}

void Dispatcher::finalize() {
}

id::Ident Dispatcher::allocID() {
	return _pool.alloc();
}

}
}

