/*******************************************************************************

  Copyright (C) 2010, 2013 LIFIA - Facultad de Informatica - Univ. Nacional de La Plata

********************************************************************************

  This file is part of DTV-util implementation.

    DTV-util is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by the Free
  Software Foundation, either version 2 of the License.

    DTV-util is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
  A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License along with
  this program. If not, see <http://www.gnu.org/licenses/>.

********************************************************************************

  Este archivo es parte de la implementación de DTV-util.

    DTV-util es Software Libre: Ud. puede redistribuirlo y/o modificarlo
  bajo los términos de la Licencia Pública General Reducida GNU como es publicada por la
  Free Software Foundation, según la versión 2 de la licencia.

    DTV-util se distribuye esperando que resulte de utilidad, pero SIN NINGUNA
  GARANTÍA; ni siquiera la garantía implícita de COMERCIALIZACIÓN o ADECUACIÓN
  PARA ALGÚN PROPÓSITO PARTICULAR. Para más detalles, revise la Licencia Pública
  General Reducida GNU.

    Ud. debería haber recibido una copia de la Licencia Pública General Reducida GNU
  junto a este programa. Si no, puede verla en <http://www.gnu.org/licenses/>.

*******************************************************************************/

#include "sockaddr.h"

#ifdef _WIN32
#	include <winsock2.h>
#	include <ws2tcpip.h>
#else
#	include <sys/socket.h>
#	include <netinet/in.h>
#	include <arpa/inet.h>
#	include <netdb.h>
#endif

//	TODO: Implement ipv6

namespace util {
namespace net {
namespace ipv6 {

SockAddr::SockAddr( void )
{
}

SockAddr::SockAddr( const SockAddr & )
{
}

SockAddr::SockAddr( struct sockaddr & )
{
}

//	Operators
SockAddr &SockAddr::operator=( const SockAddr & /*other*/ ) {
	return *this;
}

SockAddr &SockAddr::operator=( struct sockaddr_in6 & /*sa*/ ) {
	return *this;
}

SockAddr &SockAddr::operator=( struct sockaddr &sa ) {
	struct sockaddr_in6 *saddr=(struct sockaddr_in6 *)&sa;
	*this = *saddr;
	return *this;
}

SockAddr::operator struct sockaddr_in6() const {
	struct sockaddr_in6 saddr;
	saddr.sin6_family = AF_INET6;
	return saddr;
}

SockAddr::operator struct sockaddr() const {
	struct sockaddr saddr;
	saddr.sa_family = AF_INET6;
	return saddr;
}

SockAddr::operator std::string() const {
	return std::string();
}

bool SockAddr::operator==( const SockAddr & /*other*/ ) {
	return true;
}

bool SockAddr::operator==( const sockaddr_in6 & /*other*/ ) {
	return true;
}

//  Getters
Address SockAddr::address() const {
	return Address();
}

unsigned short SockAddr::port() const {
	return 10;
}

}
}
}

