/*******************************************************************************

  Copyright (C) 2010, 2013 LIFIA - Facultad de Informatica - Univ. Nacional de La Plata

********************************************************************************

  This file is part of DTV-zapper implementation.

    DTV-zapper is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by the Free
  Software Foundation, either version 2 of the License.

    DTV-zapper is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
  A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License along with
  this program. If not, see <http://www.gnu.org/licenses/>.

********************************************************************************

  Este archivo es parte de la implementación de DTV-zapper.

    DTV-zapper es Software Libre: Ud. puede redistribuirlo y/o modificarlo
  bajo los términos de la Licencia Pública General Reducida GNU como es publicada por la
  Free Software Foundation, según la versión 2 de la licencia.

    DTV-zapper se distribuye esperando que resulte de utilidad, pero SIN NINGUNA
  GARANTÍA; ni siquiera la garantía implícita de COMERCIALIZACIÓN o ADECUACIÓN
  PARA ALGÚN PROPÓSITO PARTICULAR. Para más detalles, revise la Licencia Pública
  General Reducida GNU.

    Ud. debería haber recibido una copia de la Licencia Pública General Reducida GNU
  junto a este programa. Si no, puede verla en <http://www.gnu.org/licenses/>.

*******************************************************************************/

#include "display.h"
#include <stdlib.h>

namespace zapper {
namespace display {

//	Modes
#define DO_NAME(s) #s
#define DO_CREATE_ST_MODES(n,w,h,f,t) { DO_NAME(w##x##h##t) "@" #f, DO_NAME(h##t), w, h, f, scan::t },
static Mode modes[] = {
	{ "Unknown", "Unknown", 0, 0, 0, scan::unknown },
	MODE_LIST(DO_CREATE_ST_MODES)
	{ NULL, NULL, 0, 0, 0, scan::unknown }
};
#undef DO_CREATE_ST_MODES

//	Aspect ratio
#define DO_CREATE_ST_ASPECTS(n,x,y) { #x ":" #y, x, y },
static Aspect aspects[] = {
	{ "Unknown", 0, 0 },
	{ "Auto", -1, -1 },
	ASPECT_RATIO_LIST(DO_CREATE_ST_ASPECTS)
	{ NULL, 0, 0 }
};
#undef DO_CREATE_ST_ASPECTS

//	Connectors
#define DO_CREATE_ST_CONNECTORS(n,i) #i,
static const char *connectors[] = {
	"Unknown",
	CONNECTOR_LIST(DO_CREATE_ST_CONNECTORS)
	NULL
};
#undef DO_CREATE_ST_CONNECTORS

//	Modulators
#define DO_CREATE_ST_MODULATORS(n,c) #n,
static const char *modulators[] = {
	"Unknown",
	MODULATOR_LIST(DO_CREATE_ST_MODULATORS)
	NULL
};
#undef DO_CREATE_ST_MODULATORS


//	Public methods
Mode &getMode( mode::type vMode ) {
	if (vMode >= mode::LAST_MODE) {
		vMode=mode::unknown;
	}
	return modes[vMode];
}

Aspect &getAspect( aspect::type vAspect ) {
	if (vAspect >= aspect::LAST_ASPECT) {
		vAspect=aspect::unknown;
	}
	return aspects[vAspect];
}

const char *getConnectorName( connector::type conn ) {
	if (conn >= connector::LAST_CONNECTOR) {
		conn=connector::unknown;
	}
	return connectors[conn];
}

const char *getModulatorName( modulator::type mod ) {
	if (mod >= modulator::LAST_MODULATOR) {
		mod=modulator::unknown;
	}
	return modulators[mod];
}

}	//	namespace display
}	//	namespace zapper

