/*******************************************************************************

  Copyright (C) 2010, 2013 LIFIA - Facultad de Informatica - Univ. Nacional de La Plata

********************************************************************************

  This file is part of DTV-zapper implementation.

    DTV-zapper is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by the Free
  Software Foundation, either version 2 of the License.

    DTV-zapper is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
  A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License along with
  this program. If not, see <http://www.gnu.org/licenses/>.

********************************************************************************

  Este archivo es parte de la implementación de DTV-zapper.

    DTV-zapper es Software Libre: Ud. puede redistribuirlo y/o modificarlo
  bajo los términos de la Licencia Pública General Reducida GNU como es publicada por la
  Free Software Foundation, según la versión 2 de la licencia.

    DTV-zapper se distribuye esperando que resulte de utilidad, pero SIN NINGUNA
  GARANTÍA; ni siquiera la garantía implícita de COMERCIALIZACIÓN o ADECUACIÓN
  PARA ALGÚN PROPÓSITO PARTICULAR. Para más detalles, revise la Licencia Pública
  General Reducida GNU.

    Ud. debería haber recibido una copia de la Licencia Pública General Reducida GNU
  junto a este programa. Si no, puede verla en <http://www.gnu.org/licenses/>.

*******************************************************************************/

#include "layer.h"

namespace zapper {
namespace display {

Layer::Layer( layer::type id )
{
	_id = id;
}

Layer::~Layer( void )
{
}

layer::type Layer::id() const {
	return _id;
}

bool Layer::initialize( void ) {
	return true;
}

void Layer::finalize( void ) {
}

mode::type Layer::defaultResolution() const {
	return display::mode::m576p_50;	
}

const std::vector<mode::type> Layer::supportedResolutions( void ) const {
	std::vector<mode::type> tmp;
	tmp.push_back( mode::m576p_50 );	//	SD
	tmp.push_back( mode::m720p_60 );	//	HD
	tmp.push_back( mode::m1080p_60 );	//	Full-HD
	return tmp;
}

void Layer::setMode( mode::type /*mode*/ ) {
}

void Layer::enable( void ) {
}

void Layer::disable( void ) {
}

void Layer::clear( void ) {
}

void Layer::flush( void ) {
}

//	Color key
bool Layer::setColorKey( util::BYTE /*r*/, util::BYTE /*g*/, util::BYTE /*b*/ ) {
	return true;
}

bool Layer::setAlpha( int /*alpha*/ ) {
	return true;
}

::canvas::Surface *Layer::getSurface() {
	return NULL;
}

}
}
