/*******************************************************************************

  Copyright (C) 2010, 2013 LIFIA - Facultad de Informatica - Univ. Nacional de La Plata

********************************************************************************

  This file is part of DTV-zapper implementation.

    DTV-zapper is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by the Free
  Software Foundation, either version 2 of the License.

    DTV-zapper is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
  A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License along with
  this program. If not, see <http://www.gnu.org/licenses/>.

********************************************************************************

  Este archivo es parte de la implementación de DTV-zapper.

    DTV-zapper es Software Libre: Ud. puede redistribuirlo y/o modificarlo
  bajo los términos de la Licencia Pública General Reducida GNU como es publicada por la
  Free Software Foundation, según la versión 2 de la licencia.

    DTV-zapper se distribuye esperando que resulte de utilidad, pero SIN NINGUNA
  GARANTÍA; ni siquiera la garantía implícita de COMERCIALIZACIÓN o ADECUACIÓN
  PARA ALGÚN PROPÓSITO PARTICULAR. Para más detalles, revise la Licencia Pública
  General Reducida GNU.

    Ud. debería haber recibido una copia de la Licencia Pública General Reducida GNU
  junto a este programa. Si no, puede verla en <http://www.gnu.org/licenses/>.

*******************************************************************************/

#include "scanextension.h"
#include "servicefilter.h"
#include "tuner.h"
#include "../channel/channel.h"
#include <mpegparser/service/service.h>
#include <util/log.h>

namespace zapper {

ScanExtension::ScanExtension( Tuner *tuner, ServiceFilter *filter )
{
	assert(tuner); assert(filter);
	_filter = filter;
	_tuner = tuner;
}

ScanExtension::~ScanExtension()
{
}

bool ScanExtension::mustNotify( bool /*inScan*/ ) const {
	return true;
}

//	Service notification
void ScanExtension::onServiceReady( tuner::Service *srv, bool ready ) {
	if (ready) {
		//	Find if service is supported
		if (_filter->canPlay(srv)) {
			//	Create channel
			channel::Channel *ch = new channel::Channel( srv );
			_tuner->onChannel( ch );
		} else {
			LWARN( "ScanExtension", "Service not supported: type=%02x", srv->type() );
		}
	}
}

void ScanExtension::onServiceStarted( tuner::Service *srv, bool started ) {
	//	Send to tuner
	if (started) {
		_tuner->onStartService( srv );
	}
	else {
		_tuner->onStopService( srv );
	}
}

}

