/*******************************************************************************

  Copyright (C) 2010, 2013 LIFIA - Facultad de Informatica - Univ. Nacional de La Plata

********************************************************************************

  This file is part of DTV-zapper implementation.

    DTV-zapper is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by the Free
  Software Foundation, either version 2 of the License.

    DTV-zapper is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
  A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License along with
  this program. If not, see <http://www.gnu.org/licenses/>.

********************************************************************************

  Este archivo es parte de la implementación de DTV-zapper.

    DTV-zapper es Software Libre: Ud. puede redistribuirlo y/o modificarlo
  bajo los términos de la Licencia Pública General Reducida GNU como es publicada por la
  Free Software Foundation, según la versión 2 de la licencia.

    DTV-zapper se distribuye esperando que resulte de utilidad, pero SIN NINGUNA
  GARANTÍA; ni siquiera la garantía implícita de COMERCIALIZACIÓN o ADECUACIÓN
  PARA ALGÚN PROPÓSITO PARTICULAR. Para más detalles, revise la Licencia Pública
  General Reducida GNU.

    Ud. debería haber recibido una copia de la Licencia Pública General Reducida GNU
  junto a este programa. Si no, puede verla en <http://www.gnu.org/licenses/>.

*******************************************************************************/

#include "../util.h"
#include "../../../src/channel/channelmanager.h"
#include "../../../src/plugin/pluginmanager.h"
#include "../../../src/zapper.h"
#include <util/task/dispatcherimpl.h>
#include <gtest/gtest.h>

using namespace zapper::channel;

class ServiceTest : public testing::Test {
public:
	ServiceTest( void ) : _mgr( new util::task::DispatcherImpl() ) {}
	virtual ~ServiceTest( void ) {}

	virtual void SetUp() {
		delete new zapper::Zapper("test");
		_mgr.initialize( "channelmanager_test" );
		ASSERT_TRUE( _mgr.registerService( createService() ) );
		_mgr.start();
	}
	
	virtual void TearDown() {
		_mgr.stop();
		_mgr.finalize();
	}

	zapper::plugin::PluginManager &mgr() { return _mgr; }

protected:
	virtual zapper::plugin::Service *createService( void )=0;

private:
	zapper::plugin::PluginManager _mgr;
};


class ChannelManagerTest : public ServiceTest {
public:
protected:
	virtual zapper::plugin::Service *createService( void ) {
		return new ChannelManager(true);
	}	
};

TEST_F( ChannelManagerTest, initialize_start_stop_finalize ) {
}
